/**
    Task õ Լ  

    Written KKAMAGUI, http://kkamagui.egloos.com
*/
#include "Task.h"
#include "Asm.h"

/**
    Task  ó
*/
void kTaskEnd( void )
{
    // ʿ  
    while( 1 ) ;
}

/**
    TASK ü Ѵ.
*/
BOOL kSetupTask( PTASK pstTask, void* pfStartAddr, void* pfEndAddr )
{
    DWORD* pdwStackTop;

    // ü ʱȭ Ѵ.
    kMemSet( pstTask, 0, sizeof( pstTask->vdwStack ) );

    // Stack Top
    pdwStackTop = ( DWORD* ) ( pstTask->vdwStack + ( MAX_STACKSIZE - 1 ) );

    // ESP, EBP, EFLAG, EAX, EBX, ECX, EDX, ESI, EDI  Push Ѵ.
    pstTask->vdwStack[ 14 ] = ( DWORD ) ( pdwStackTop - 1 );
    pstTask->vdwStack[ 13 ] = ( DWORD ) ( pdwStackTop - 1 );
    pstTask->vdwStack[ 12 ] = EFLAG_DEFAULT;

    // cs, ds, ss, es, fs, gs kernel ⺻  ش.
    pstTask->vdwStack[ 5 ] = GDT_VAR_KERNELCODEDESC;
    pstTask->vdwStack[ 4 ] = GDT_VAR_KERNELDATADESC;
    pstTask->vdwStack[ 3 ] = GDT_VAR_KERNELDATADESC;
    pstTask->vdwStack[ 2 ] = GDT_VAR_KERNELDATADESC;
    pstTask->vdwStack[ 1 ] = GDT_VAR_KERNELDATADESC;
    pstTask->vdwStack[ 0 ] = GDT_VAR_KERNELDATADESC;

    //  Stack Return Address pfAddr  ش.
    pdwStackTop[ -1 ] = ( DWORD ) pfStartAddr;
    //  Task  Լ   Default 
    if( pfEndAddr != NULL )
    {
        pdwStackTop[ 0 ] = ( DWORD ) pfEndAddr;
    }
    else
    {
        pdwStackTop[ 0 ] = ( DWORD ) kTaskEnd;
    }
    return TRUE;
}
